Attribute VB_Name = "modMain"
Option Explicit
Dim IOB As WINPLCIOLib.IOBase
Dim Port1 As WPLCCommLib.CommPort
Dim Port2 As WPLCCommLib.CommPort
Dim Port3 As WPLCCommLib.CommPort
Dim s As String
Dim Cnt As Long

Sub Main()
    On Error Resume Next
    Set IOB = CreateObject("WinPLCIO.IOBase")
    
    IOB.OutputDebugString "Initializing..."
    IOB.Init
    
    IOB.TurnOnRunLED
    IOB.OutputDebugString "Running..."
    
    Set Port1 = CreateObject("WPLCComm.CommPort")
    Set Port2 = CreateObject("WPLCComm.CommPort")
    Set Port3 = CreateObject("WPLCComm.CommPort")

    Rc = Port1.Open("COM2:", 19200, 8, 0, 1)
    Rc = Port2.Open("COM3:", 19200, 8, 0, 1)
    Rc = Port3.Open("COM4:", 19200, 8, 0, 1)
    
    s = "Hello Fred!"
    
    Port1.Send s, 21
    
    While IOB.GetDI(0, 0) = False
        IOB.ReadIO
        
        Cnt = Port1.GetRxAvailable
        If Cnt > 0 Then
            s = Port1.Receive(Cnt)
            Cnt = Len(s)
            Port1.Send s, Cnt
        End If
        
        Cnt = Port2.GetRxAvailable
        If Cnt > 0 Then
            s = Port2.Receive(Cnt)
            Cnt = Len(s)
            Port2.Send s, Cnt
        End If
            
        Cnt = Port3.GetRxAvailable
        If Cnt > 0 Then
            s = Port3.Receive(Cnt)
            Cnt = Len(s)
            Port3.Send s, Cnt
        End If
        
        IOB.WriteIO
        IOB.DoIdle 5
    Wend
    
    Port1.Close
    Port2.Close
    Port3.Close
            
    IOB.OutputDebugString "Exiting..."
    IOB.ClearOutputs
    IOB.WriteIO
    
    IOB.TurnOffRunLED
   
    IOB.Exit
End Sub

