// FlashFile.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <iobase.h>

int TestFileSys()
{
	HANDLE h= CreateFile( TEXT( "\\FlashDrive\\test1.fil" ), GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL );
 
	if( h != INVALID_HANDLE_VALUE )
	{
		BYTE Buffer[100];
		
		int x;
		
		DWORD dWord;
 
		RETAILMSG( 1, ( TEXT( "\nCreateFile Success!\n" ) ) );
 
		for( x= 0; x < sizeof( Buffer ); x++ )
			Buffer[x]= x;
 
		if( !WriteFile( h, Buffer, sizeof( Buffer ), &dWord, NULL ) )
			RETAILMSG( 1, ( TEXT( "\nWriteFile failed LastError: %d\n" ), GetLastError() ) );
		else
			RETAILMSG( 1, ( TEXT( "\nWriteFile Success!\n") ) );
 
		CloseHandle( h );
 
		h= CreateFile( TEXT( "\\FlashDrive\\test1.fil" ), GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL );
 
		if( h != INVALID_HANDLE_VALUE )
		{
			int Diffs= 0;
			memset( Buffer, 0, sizeof( Buffer ) );
 
			RETAILMSG( 1, ( TEXT( "\nOpenFile Success!\n") ) );
 
			if( !ReadFile( h, Buffer, sizeof( Buffer ), &dWord, NULL ) )
				RETAILMSG( 1, ( TEXT( "\nReadFile failed LastError: %d\n" ), GetLastError() ) );
			else
				RETAILMSG( 1, ( TEXT( "\nReadFile Success!\n") ) );
 
			for( x= 0; x< sizeof( Buffer ); x++ )
			{
				if( Buffer[x]!= x )
				{
					RETAILMSG( 1, ( TEXT( "\nBuffer[x]== %d  x== %d\n" ), Buffer[x], x ) );
					Diffs++;
				}
			}
 
			if( Diffs )
				RETAILMSG( 1, ( TEXT( "\nTotal Differences: %d\n" ), Diffs ) );
			else
				RETAILMSG( 1, ( TEXT( "\nVerify Success!\n" ) ) );
 
			CloseHandle( h );
		
		}else
			RETAILMSG( 1, ( TEXT( "\nOpenFile failed LastError: %d\n" ), GetLastError() ) );
	}else
	{
		RETAILMSG( 1, ( TEXT( "\nCreateFile failed LastError: %d\n" ), GetLastError() ) );
	}
 
	return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	OutputDebugString( TEXT( "FlashFile started!" ) );

	// Set thread priority to highest. This dramatically improves scan consistency.
	SetThreadPriority( GetCurrentThread(), THREAD_PRIORITY_TIME_CRITICAL );

	// Create and initialize the I/O base interface
	CIOBase IOB;
	IOB.Init();

/*
** TO DO: Do power on initialization here
*/
//	CommPortEcho();

	int rc= TestFileSys();
	

	// Turn on the run mode LED
	IOB.TurnOnRunLED();	


/*
** TO DO: Solve logic here
*/

/*
** TO DO: Clean up here
*/


	// Turn off the run mode LED
	IOB.TurnOffRunLED();
	
	
	// Clean up I/O base interface
	IOB.Exit();

	OutputDebugString( TEXT( "FlashFile exiting. Bye!" ) );

	return 0;
}

