Attribute VB_Name = "modMain"
Option Explicit
Dim IOB As WinPLCIOLib.IOBase
Dim MB1 As MBVBlib.MailBoxVB
Dim s As String
Dim hMBC As Long
Dim Rc As Integer

Sub Main()
    Set IOB = CreateObject("WinPLCIO.IOBase")
    
    IOB.OutputDebugString "Initializing..."
    IOB.Init
    
    IOB.TurnOnRunLED
    IOB.OutputDebugString "Running..."
    
    ' Create the mailbox
    Set MB1 = CreateObject("MBVB.MailBoxVB")
    ' Initialize to desired port
    Rc = MB1.InitializeMailbox(&H7171)
    ' Create connection to device you want to talk to
    hMBC = MB1.CreateConnection("192.168.11.2", 100, 3)
    
    s = "Hello Fred!" + Chr(10)
   
    While IOB.GetDI(0, 0) = False
        IOB.ReadIO
        
        ' Send message to remote device
        Rc = MB1.SendMsg(hMBC, s)
        
        ' Check for incoming messages
        While MB1.MessagesAvailable <> 0
            ' Pop message off stack
            MB1.GetNextMsg
            ' Data is in MB1.MsgData - source address in MB1.MsgSource
            IOB.OutputDebugString MB1.MsgData
        Wend
       
        IOB.WriteIO
        IOB.DoIdle 1000
    Wend
    
    ' Destroy connection
    MB1.DestroyConnection hMBC
            
    IOB.OutputDebugString "Exiting..."
    IOB.ClearOutputs
    IOB.WriteIO
    
    IOB.TurnOffRunLED
   
    IOB.Exit
End Sub

