// MBPCC.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "\HAPTools\SDK\include\mbpc_api.h"
#include "winsock.h"

int main(int argc, char* argv[])
{
	DWORD Addr;
	char Buff[512];
	WORD Length = 512;
	DWORD Source;

	printf("MailBox PC Sample Client!\n");

	if(argc > 1)
		Addr = inet_addr(argv[1]);
	else
		Addr = 0xFFFFFFFF;

	HMAILBOX hMB = CreateMailbox(0x7171);
//	HMBC hMBC = CreateConnectionS(hMB, "192.168.11.2", 100, 3);
	HMBC hMBC = CreateConnection(hMB, Addr, 100, 3);

	DWORD StartTime = GetTickCount();
	
	while(1)
		{
		if(CheckConnection(hMB, hMBC))
			printf("Remote responded...\n");
		else
			printf("Error pinging remote...\n");

		wsprintf(Buff, "Hello there %s!\n", argv[1]);
		SendMsg(hMB, hMBC, (BYTE *)Buff, strlen(Buff)+1);

		while(IncomingMessagesAvailable(hMB))
			{
			Length = 512;
			if(GetIncomingMessage(hMB, (BYTE *)Buff, &Length, &Source))
				printf(Buff);
			}
		
		Sleep(1000);
		}

	DestroyConnection(hMB, hMBC);
	DestroyMailbox(hMB);

	return 0;
}

