#ifndef __MBPC_API_H
#define __MBPC_API_H

#ifdef __cplusplus
extern "C" {
#endif

typedef HANDLE HMBC;
typedef HANDLE HMAILBOX;

HMAILBOX CreateMailbox(WORD Port);
void DestroyMailbox(HMAILBOX hMB);

HMBC CreateConnection(HMAILBOX hMB, DWORD Address, WORD Timeout, WORD Retries);
HMBC CreateConnectionS(HMAILBOX hMB, LPCSTR pStr, WORD Timeout, WORD Retries);
void DestroyConnection(HMAILBOX hMB, HMBC hMBC);
BOOL CheckConnection(HMAILBOX hMB, HMBC hMBC);

BOOL SendMsg(HMAILBOX hMB, HMBC hMBC, BYTE *pData, WORD Length);
int IncomingMessagesAvailable(HMAILBOX hMB);
BOOL GetIncomingMessage(HMAILBOX hMB, BYTE *pData, WORD *pLength, DWORD *pSourceAddress);

#ifdef __cplusplus
}
#endif

#endif // __MBPC_API_H
